<template>
	<view class="m_right">
		<view class="m_right_hander">
			<!-- <button size="mini" class="m_btn_red" @click="addZc()">添加资产</button> -->
		</view>
		<view class="m_right_container">
			<table style="width: 100%;border: 1px solid #DDDDDD;border-collapse: collapse">
				<thead class="m-table-hander">
					<tr>
						<th>资产预览图</th>
						<th>资产名称</th>
						<th>上传人</th>
						<th>上传时间</th>
						<th>删除</th>
					</tr>
				</thead>
				<tbody>
					<tr v-for="(dataUser,dataUserI) in dataUsers_all" :key="dataUserI">
						<th>
							<image class="m_logoimg" :src="dataUser.Texture_Url" mode=""></image>
						</th>
						<th>{{dataUser.Name}}</th>
						<th>{{dataUser.CreateUserName}}</th>
						<th>{{dataUser.UploadTime}}</th>
						<th style="position: relative;"><button type="default" size="mini" class="m_delete" @click="deleteZc(dataUser)">删除</button></th>
					</tr>
				</tbody>
			</table>
		</view>
		<view class="m_right_footer">
			<view class="m_paging">
				<text class="m_paging_item m_paging_upper" v-show="bShowLastPageBtn" @click="last()">上一页</text>
				<text class="m_paging_item" v-for="i in pageTotalNum" @click="paging(i)" :key="i" :class="i==currentPage?'p_act':''">
					{{i}}
				</text>
				<text class="m_paging_item m_paging_lower" v-show="bShowNextPageBtn" @click="paging(i)">下一页</text>
			</view>
		</view>
		<popForm ref="popForm"></popForm>
		<popAlert ref="popAlert"></popAlert>
	</view>
</template>

<script>
	import popForm from '@/components/popForm.vue'
	import popAlert from '@/components/popAlert.vue'
	
	export default {
		name: "manager_assets",
		components: {
			popForm,
			popAlert,
		},
		data() {
			return {
				pageTotalNum:1,
				currentPage:1,
				totalItem:2,
				dataUsers_all: [],
				bShowLastPageBtn:false,
				bShowNextPageBtn:false,
			}
		},
		methods: {
			paging(i) {
				uni.showLoading({
				    title: '加载中'  
				});
				
				let fromIndex = this.totalItem*(i-1);
				let toIndex = fromIndex+this.totalItem;
				
				let data = {
					"UserID": mydata_userInfo.userID,
					"BeginNum": fromIndex, //用户数组索引
					"EndNum": toIndex, //用户数组索引结束
					"ItemType":""//道具 角色 场景  空为全部
				}
				
				uni.request({
					header: {
						'Content-Type': 'application/json;charset=UTF-8'
					},
					url: mydata_api + '/item/getitemlist',
					method: 'POST',
					data: data,
					dataType: 'json',
					success: (res) => {
						//100成功
						if (res.data.Code == 100) {
							console.log("请求全部资产", res);
							this.dataUsers_all = res.data.Items;
							this.pageTotalNum = Math.ceil(res.data.AllOfItem/this.totalItem);
							this.currentPage = i;					
							this.showNextOrLastPageBtn();
						}
						//200失败
						else {
							console.log('suc200', res);
						}
						uni.hideLoading();					
					},
					fail: (res) => {
						console.log("请求失败****");	
						uni.hideLoading();
					}
				});
			},
			initPage() {
				this.paging(1);
			},
			last()
			{
				this.currentPage--;
				this.paging(this.currentPage);
			},
			next()
			{
				this.currentPage++;
				this.paging(this.currentPage);
			},
			showNextOrLastPageBtn()
			{
				if(this.pageTotalNum==this.currentPage)
				{
					this.bShowLastPageBtn = true;
					this.bShowNextPageBtn = false;
					// console.log('11111')
				}
				else if(1==this.currentPage)
				{
					this.bShowLastPageBtn = false;
					this.bShowNextPageBtn = true;
					// console.log('2222')
				}
				else
				{
					this.bShowLastPageBtn = true;
					this.bShowNextPageBtn = true;
					// console.log('333333')
				}
				
				if(this.pageTotalNum==1){
					this.bShowLastPageBtn = false;
					this.bShowNextPageBtn = false;
					// console.log('444444')
				}
			},
			addZc(){
				
				uni.chooseFile({
					success: (chooseFileRes) => 
					{
						console.log('选择文件成功')
						const tempFilePaths = chooseFileRes.tempFilePaths;
												
						this.$refs.popForm.isShow(true);
						this.$refs.popForm.setTitle('添加资产');
						
						let _self = this;
						let callback = function(content_arr){
							
							let data = {
								"UserID":mydata_userInfo.userID,
								"ItemName":content_arr[0].input,
							}
							console.log('data===',data)
							uni.showLoading({
							    title: '上传中'  
							});
							
							uni.uploadFile({
								url: mydata_api + '/item/uploadfile', 
								filePath: tempFilePaths[0],
								name: 'file',
								formData:data,
								success: (uploadFileRes) => {								
									console.log("上传资产成功", uploadFileRes);
									_self.paging(_self.currentPage);																	
									uni.hideLoading();
								},
								fail: (res) => {
									console.log("上传失败");
									uni.hideLoading();
								}
							});
						};
						
						this.$refs.popForm.setContent([
							{
								'name':'物品名称',
								'input':'',
								'type' :'text'
							}
						],callback);						
					}
				});	
			},
			deleteZc(dataUser)
			{
				this.$refs.popAlert.isShow(true);	
				this.$refs.popAlert.setTitle('提示');
				let _self = this;	
				let callback = function(){
					let data = {
						"UserID":mydata_userInfo.userID,
						"ItemID":[dataUser.Id]
					}
					
					uni.showLoading({
					    title: '删除中'  
					});
					
					uni.request({
						header: {
							'Content-Type': 'application/json;charset=UTF-8'
						},
						url: mydata_api + '/backstage/deleteitem',
						method: 'POST',
						data: data,
						dataType: 'json',
						success: (res) => {
							//100成功
							if (res.data.Code == 100) {
								console.log("删除资产成功", res);
								_self.paging(_self.currentPage);
							}
							//200失败
							else {
								console.log('删除用户资产失败200', res);
							}
							
							uni.hideLoading();
						},
						fail: (res) => {
							console.log("删除用户资产失败");
							uni.hideLoading();
						}
					});
				}
				
				this.$refs.popAlert.setContent('是否删除资产',callback);
			},
		}
	}
</script>

<style lang="scss">
	// 允许文字被选择
	th
	{
	moz-user-select: -moz-text;
	-moz-user-select: text;
	-o-user-select: text;
	-khtml-user-select: text;
	-webkit-user-select: text;
	-ms-user-select: text;
	user-select: text;
	}
	
	.m_right {
		width: 100%;
		margin-top: 5rpx;
		padding: 0 150rpx;
		background-color: #fff;
		box-shadow: 3px 0px 6px 0px rgba(0, 0, 0, 0.1);

		.m_right_hander {
			text-align: right;
			height: 250rpx;
			position: relative;

			.m_btn_red {
				position: absolute;
				height: 80rpx;
				line-height: 80rpx;
				padding: 0 40rpx;
				right: 0;
				top: 50%;
				transform: translateY(-50%);
				background: #EA252C;
				color: #fff;
			}
		}

	}

	tbody tr {
		// border-top: 2rpx solid #DDDDDD !important;
		border: 2rpx solid #DDDDDD !important;
	}
	
	th {
		border: 2rpx solid #DDDDDD !important;
	}

	tbody tr th:first-child {
		position: relative;
	}

	tbody tr th {
		font-weight: 400 !important;
		height: 140rpx;
		line-height: 140rpx;
	}

	// tbody tr:hover {
	// 	// color: #fff;
	// 	background: #FDEBEC;
	// 	// opacity: 0.08;
	// }

	.m-table-hander {
		background-color: #FFF8F7;
		height: 140rpx;
		line-height: 140rpx;
		font-family: MicrosoftYaHei-Bold, MicrosoftYaHei;
		font-weight: bold;
	}

	.m_edit {
		position: absolute;
		top: 50%;
		left: 50%;
		transform: translate(-50%, -50%);
		background: rgb(67, 127, 250);
		color: rgb(255, 255, 255);
		min-width: 130rpx;
	}

	.m_delete {
		// position: absolute;
		// top: 50%;
		// left: 50%;
		// min-width: 130rpx;
		// transform: translate(-50%, -50%);
		// background: rgb(234, 37, 44);
		// color: rgb(255, 255, 255);
		
		background: rgb(234, 37, 44);
		color: rgb(255, 255, 255);
	}

	.m_right_footer {
		margin-top: 80rpx;
	}

	.m_logoimg {
		width: 80rpx;
		height: 80rpx;
		position: absolute;
		top: 50%;
		left: 50%;
		transform: translate(-50%,-50%);
	}

	.m_paging {
		text-align: right;

		.m_paging_item {
			padding: 10rpx 18rpx;
			border: 1rpx solid #DDDDDD;
			border-radius: 8rpx;
			margin-right: 10rpx;
		}

		.p_act {
			background: #EA252C;
			color: #fff;
			border: inherit;
		}
	}

	.m_paging_item:hover {
		background: #EA252C;
		color: #fff;
		border: inherit;
	}

	.m_act1 {
		color: #FF0019;
	}
</style>
